package jp.sf.pal.nvwidget.service;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Serializable;
import java.net.URL;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import jp.sf.pal.nvwidget.NvWidgetException;
import jp.sf.pal.nvwidget.entity.NvWidget;
import jp.sf.pal.nvwidget.pager.NvWidgetPager;
import jp.sf.pal.nvwidget.util.NvWidgetHandler;
import jp.sf.pal.nvwidget.util.NvWidgetList;

import org.xml.sax.InputSource;

public class NvWidgetService implements Serializable {

    private static final long serialVersionUID = 6932901501995247897L;

    public NvWidgetList<NvWidget> getNvWidgetList(NvWidgetPager pager)
            throws NvWidgetException {
        try {
            SAXParserFactory spfactory = SAXParserFactory.newInstance();
            SAXParser parser = spfactory.newSAXParser();
            NvWidgetHandler nvWidgetHandler = new NvWidgetHandler(pager);
            Object content = new URL(pager.buildUrl()).getContent();
            if (content instanceof InputStream) {
                parser.parse(new InputSource(new InputStreamReader(
                        (InputStream) content, "UTF-8")), nvWidgetHandler);
                return nvWidgetHandler.getNvWidgetList();
            }
            throw new NvWidgetException("Invalid content: " + content);
        } catch (Exception e) {
            throw new NvWidgetException(e);
        }

    }
}
